#include "../_common/benchmark.hpp"
#include "./palmtree/palmtree.h"

#include "../_common/benchmark.hpp"

int main() {
  using KeyType = int32_t;
  using ValueType = int32_t;

  google::InitGoogleLogging("XXX");
  google::SetCommandLineOption("GLOG_minloglevel", "3");

  Benchmark::execute<Benchmark::Device::Host, KeyType>(
      "palm", [](auto &timer, std::vector<KeyType> input) {
        palmtree::PalmTree<KeyType, ValueType> tree(INT32_MIN, 1);
        size_t size = input.size();

        timer.start();
        for (KeyType key : input) {
          tree.insert(key, key);
        }
        timer.stop("insert");

        timer.start();
        for (KeyType key : input) {
          ValueType value;
          tree.find(key, value);
        }
        timer.stop("query");
      });

  return 0;
}
