#include <cstdlib>
#include <iostream>
#include <map>
#include <time.h>
#include <unistd.h>

#include "../_common/benchmark.hpp"

int main() {
  using KeyType = uint32_t;
  using ValueType = uint32_t;

  Benchmark::execute<Benchmark::Device::Host, KeyType>(
      "std::map", [](auto &timer, std::vector<KeyType> input) {
        std::map<KeyType, ValueType> map;
        timer.start();
        for (auto i : input) {
          map.insert(std::make_pair(i, i));
        }

        timer.stop("insert");

        size_t size = input.size();
        std::vector<std::map<KeyType, ValueType>::iterator> results(size);

        timer.start();
        for (size_t i = 0; i < size; ++i) {
          results[i] = map.find(input[i]);
        }
        timer.stop("query");
      });

  return 0;
}
