#include <cstdlib>
#include <iostream>
#include <stx/btree_map.h>
#include <time.h>
#include <unistd.h>

#include "../_common/benchmark.hpp"

int main() {
  using KeyType = uint32_t;
  using ValueType = uint32_t;

  Benchmark::execute<Benchmark::Device::Host, KeyType>(
      "stx::map", [](auto &timer, std::vector<KeyType> input) {
        stx::btree_map<KeyType, ValueType> map;
        timer.start();
        for (auto i : input) {
          map.insert(std::make_pair(i, i));
        }
        timer.stop("insert");

        size_t size = input.size();
        std::vector<stx::btree_map<KeyType, ValueType>::iterator> results(size);

        timer.start();
        for (auto i : input) {
          results.emplace_back(map.find(i));
        }
        timer.stop("query");
      });

  return 0;
}
