/** @jsxImportSource @emotion/react */
import { useState } from "react"
import { Playback } from "./core/node"

import { css, Global } from "@emotion/react"
import { InputEditor } from "./components/InputEditor"
import { PlaybackViewer } from "./components/PlaybackViewer"

function App() {
  const [playback, setPlayback] = useState<Playback | null>(null)

  return (
    <>
      <Global
        styles={css`
          body {
            font-family: "Fira Code", monospace;
            padding: 0;
            margin: 0;
          }

          textarea, pre {
            font-family: "Fira Code", monospace;
          }
        `}
      />
      {playback ? (
        <PlaybackViewer playback={playback} />
      ) : (
        <InputEditor onSuccess={setPlayback} />
      )}
    </>
  )
}

export default App
