/** @jsxImportSource @emotion/react */
import { useState } from "react"
import { Playback } from "../core/node"
import { css } from "@emotion/react"

export function InputEditor(props: {
  onSuccess?: (playback: Playback) => void
}) {
  const [lines, setLines] = useState("")
  return (
    <form
      onSubmit={(e) => {
        e.preventDefault()
        props.onSuccess?.(new Playback(lines.trim().split("\n")))
      }}
      css={css`
        display: flex;
        flex-direction: column;
        align-items: flex-start;
        gap: 10px;
      `}
    >
      <textarea
        value={lines}
        onChange={(e) => setLines(e.target.value)}
        autoComplete="off"
        autoCorrect="off"
        autoCapitalize="off"
        spellCheck="false"
        css={{ minHeight: 300, minWidth: 600 }}
      />
      <button type="submit">Insert</button>
    </form>
  )
}
