/** @jsxImportSource @emotion/react */
import { useState } from "react"

export function RootEditor(props: {
  value: string
  onChange: (value: string) => void
}) {
  const [state, setState] = useState(props.value)

  return (
    <form
      onSubmit={(e) => {
        e.preventDefault()

        setState(state)
        props.onChange(state)
      }}
    >
      <input
        type="text"
        value={state}
        onChange={(e) => setState(e.target.value)}
      />
      <button type="submit">Set root</button>
    </form>
  )
}
