#pragma once
#include "TNL/Cuda/CudaCallable.h"
#include <TNL/Devices/Cuda.h>
#include <TNL/Devices/Host.h>
#include <TNL/Exceptions/CudaSupportMissing.h>

#include "../Constants.hpp"

using namespace TNL;

template <typename Object, typename Device> struct BNodeLatch;

template <template <typename KeyType, typename ValueType, size_t Order> class BNode,
          typename KeyType, typename ValueType, size_t Order>
struct BNodeLatch<BNode<KeyType, ValueType, Order>, Devices::Host> {
  using BTreeNode = BNode<KeyType, ValueType, Order>;

  void acquire(BTreeNode *node) {
    bool locked = true;

    while (locked) {
      if (node->mWriteLock == false) {
        node->mWriteLock = true;
        break;
      }
    }
  }

  bool attempt(BTreeNode *node) {
    if (node->mWriteLock == false) {
      node->mWriteLock = true;
      return true;
    }
    return false;
  }

  void release(BTreeNode *node) { node->mWriteLock = false; }
};
