#pragma once
#include <TNL/Assert.h>
#include <TNL/Cuda/CudaCallable.h>
#include <TNL/TypeTraits.h>
#include <iostream>
#include <sstream>
#include <stdint.h>
#include <string>
#include <vector>

template <typename _KeyType, typename _ValueType, size_t Order> struct BPlusNode {
  using KeyType = _KeyType;
  using ValueType = _ValueType;

  BPlusNode *mSibling;

  KeyType mHighKey;
  uint16_t mHighKeyFlag;

  uint16_t mLeaf;
  uint16_t mSize;

  int mWriteLock = false;

  KeyType mKeys[Order];
  ValueType mValues[Order];
  BPlusNode *mChildren[Order];

  __cuda_callable__ inline uint16_t childSize() {
    if (this->mLeaf == false && this->mSize > 0) {
      return this->mSize + 1;
    }
    return this->mSize;
  }

  __cuda_callable__ inline bool isFull() { return mSize + (mLeaf == false) >= Order; }
};